import type { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, ContractTransaction, Overrides, PayableOverrides, PopulatedTransaction, Signer, utils } from "ethers";
import type { FunctionFragment, Result, EventFragment } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type { TypedEventFilter, TypedEvent, TypedListener, OnEvent, PromiseOrValue } from "../../../../common";
export interface ISuperComposableYieldInterface extends utils.Interface {
    functions: {
        "accruedRewards(address)": FunctionFragment;
        "assetInfo()": FunctionFragment;
        "claimRewards(address)": FunctionFragment;
        "deposit(address,address,uint256,uint256)": FunctionFragment;
        "exchangeRateCurrent()": FunctionFragment;
        "exchangeRateStored()": FunctionFragment;
        "getBaseTokens()": FunctionFragment;
        "getRewardTokens()": FunctionFragment;
        "isValidBaseToken(address)": FunctionFragment;
        "redeem(address,uint256,address,uint256)": FunctionFragment;
        "yieldToken()": FunctionFragment;
    };
    getFunction(nameOrSignatureOrTopic: "accruedRewards" | "assetInfo" | "claimRewards" | "deposit" | "exchangeRateCurrent" | "exchangeRateStored" | "getBaseTokens" | "getRewardTokens" | "isValidBaseToken" | "redeem" | "yieldToken"): FunctionFragment;
    encodeFunctionData(functionFragment: "accruedRewards", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "assetInfo", values?: undefined): string;
    encodeFunctionData(functionFragment: "claimRewards", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "deposit", values: [
        PromiseOrValue<string>,
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BigNumberish>
    ]): string;
    encodeFunctionData(functionFragment: "exchangeRateCurrent", values?: undefined): string;
    encodeFunctionData(functionFragment: "exchangeRateStored", values?: undefined): string;
    encodeFunctionData(functionFragment: "getBaseTokens", values?: undefined): string;
    encodeFunctionData(functionFragment: "getRewardTokens", values?: undefined): string;
    encodeFunctionData(functionFragment: "isValidBaseToken", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "redeem", values: [
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>
    ]): string;
    encodeFunctionData(functionFragment: "yieldToken", values?: undefined): string;
    decodeFunctionResult(functionFragment: "accruedRewards", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "assetInfo", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "claimRewards", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "deposit", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "exchangeRateCurrent", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "exchangeRateStored", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getBaseTokens", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getRewardTokens", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "isValidBaseToken", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "redeem", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "yieldToken", data: BytesLike): Result;
    events: {
        "ClaimRewards(address,address[],uint256[])": EventFragment;
        "Deposit(address,address,address,uint256,uint256)": EventFragment;
        "ExchangeRateUpdated(uint256,uint256)": EventFragment;
        "Redeem(address,address,address,uint256,uint256)": EventFragment;
    };
    getEvent(nameOrSignatureOrTopic: "ClaimRewards"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "Deposit"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "ExchangeRateUpdated"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "Redeem"): EventFragment;
}
export interface ClaimRewardsEventObject {
    user: string;
    rewardTokens: string[];
    rewardAmounts: BigNumber[];
}
export type ClaimRewardsEvent = TypedEvent<[
    string,
    string[],
    BigNumber[]
], ClaimRewardsEventObject>;
export type ClaimRewardsEventFilter = TypedEventFilter<ClaimRewardsEvent>;
export interface DepositEventObject {
    caller: string;
    receiver: string;
    tokenIn: string;
    amountDeposited: BigNumber;
    amountScyOut: BigNumber;
}
export type DepositEvent = TypedEvent<[
    string,
    string,
    string,
    BigNumber,
    BigNumber
], DepositEventObject>;
export type DepositEventFilter = TypedEventFilter<DepositEvent>;
export interface ExchangeRateUpdatedEventObject {
    oldExchangeRate: BigNumber;
    newExchangeRate: BigNumber;
}
export type ExchangeRateUpdatedEvent = TypedEvent<[
    BigNumber,
    BigNumber
], ExchangeRateUpdatedEventObject>;
export type ExchangeRateUpdatedEventFilter = TypedEventFilter<ExchangeRateUpdatedEvent>;
export interface RedeemEventObject {
    caller: string;
    receiver: string;
    tokenOut: string;
    amountScyToRedeem: BigNumber;
    amountTokenOut: BigNumber;
}
export type RedeemEvent = TypedEvent<[
    string,
    string,
    string,
    BigNumber,
    BigNumber
], RedeemEventObject>;
export type RedeemEventFilter = TypedEventFilter<RedeemEvent>;
export interface ISuperComposableYield extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: ISuperComposableYieldInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        accruedRewards(user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[BigNumber[]] & {
            rewardAmounts: BigNumber[];
        }>;
        assetInfo(overrides?: CallOverrides): Promise<[
            number,
            string,
            number
        ] & {
            assetType: number;
            assetAddress: string;
            assetDecimals: number;
        }>;
        claimRewards(user: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        deposit(receiver: PromiseOrValue<string>, tokenIn: PromiseOrValue<string>, amountTokenToPull: PromiseOrValue<BigNumberish>, minSharesOut: PromiseOrValue<BigNumberish>, overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        exchangeRateCurrent(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        exchangeRateStored(overrides?: CallOverrides): Promise<[BigNumber] & {
            res: BigNumber;
        }>;
        getBaseTokens(overrides?: CallOverrides): Promise<[string[]] & {
            res: string[];
        }>;
        getRewardTokens(overrides?: CallOverrides): Promise<[string[]]>;
        isValidBaseToken(token: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[boolean]>;
        redeem(receiver: PromiseOrValue<string>, amountSharesToPull: PromiseOrValue<BigNumberish>, tokenOut: PromiseOrValue<string>, minTokenOut: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        yieldToken(overrides?: CallOverrides): Promise<[string]>;
    };
    accruedRewards(user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber[]>;
    assetInfo(overrides?: CallOverrides): Promise<[
        number,
        string,
        number
    ] & {
        assetType: number;
        assetAddress: string;
        assetDecimals: number;
    }>;
    claimRewards(user: PromiseOrValue<string>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    deposit(receiver: PromiseOrValue<string>, tokenIn: PromiseOrValue<string>, amountTokenToPull: PromiseOrValue<BigNumberish>, minSharesOut: PromiseOrValue<BigNumberish>, overrides?: PayableOverrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    exchangeRateCurrent(overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    exchangeRateStored(overrides?: CallOverrides): Promise<BigNumber>;
    getBaseTokens(overrides?: CallOverrides): Promise<string[]>;
    getRewardTokens(overrides?: CallOverrides): Promise<string[]>;
    isValidBaseToken(token: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
    redeem(receiver: PromiseOrValue<string>, amountSharesToPull: PromiseOrValue<BigNumberish>, tokenOut: PromiseOrValue<string>, minTokenOut: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    yieldToken(overrides?: CallOverrides): Promise<string>;
    callStatic: {
        accruedRewards(user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber[]>;
        assetInfo(overrides?: CallOverrides): Promise<[
            number,
            string,
            number
        ] & {
            assetType: number;
            assetAddress: string;
            assetDecimals: number;
        }>;
        claimRewards(user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber[]>;
        deposit(receiver: PromiseOrValue<string>, tokenIn: PromiseOrValue<string>, amountTokenToPull: PromiseOrValue<BigNumberish>, minSharesOut: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        exchangeRateCurrent(overrides?: CallOverrides): Promise<BigNumber>;
        exchangeRateStored(overrides?: CallOverrides): Promise<BigNumber>;
        getBaseTokens(overrides?: CallOverrides): Promise<string[]>;
        getRewardTokens(overrides?: CallOverrides): Promise<string[]>;
        isValidBaseToken(token: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
        redeem(receiver: PromiseOrValue<string>, amountSharesToPull: PromiseOrValue<BigNumberish>, tokenOut: PromiseOrValue<string>, minTokenOut: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        yieldToken(overrides?: CallOverrides): Promise<string>;
    };
    filters: {
        "ClaimRewards(address,address[],uint256[])"(user?: PromiseOrValue<string> | null, rewardTokens?: null, rewardAmounts?: null): ClaimRewardsEventFilter;
        ClaimRewards(user?: PromiseOrValue<string> | null, rewardTokens?: null, rewardAmounts?: null): ClaimRewardsEventFilter;
        "Deposit(address,address,address,uint256,uint256)"(caller?: PromiseOrValue<string> | null, receiver?: PromiseOrValue<string> | null, tokenIn?: PromiseOrValue<string> | null, amountDeposited?: null, amountScyOut?: null): DepositEventFilter;
        Deposit(caller?: PromiseOrValue<string> | null, receiver?: PromiseOrValue<string> | null, tokenIn?: PromiseOrValue<string> | null, amountDeposited?: null, amountScyOut?: null): DepositEventFilter;
        "ExchangeRateUpdated(uint256,uint256)"(oldExchangeRate?: null, newExchangeRate?: null): ExchangeRateUpdatedEventFilter;
        ExchangeRateUpdated(oldExchangeRate?: null, newExchangeRate?: null): ExchangeRateUpdatedEventFilter;
        "Redeem(address,address,address,uint256,uint256)"(caller?: PromiseOrValue<string> | null, receiver?: PromiseOrValue<string> | null, tokenOut?: PromiseOrValue<string> | null, amountScyToRedeem?: null, amountTokenOut?: null): RedeemEventFilter;
        Redeem(caller?: PromiseOrValue<string> | null, receiver?: PromiseOrValue<string> | null, tokenOut?: PromiseOrValue<string> | null, amountScyToRedeem?: null, amountTokenOut?: null): RedeemEventFilter;
    };
    estimateGas: {
        accruedRewards(user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        assetInfo(overrides?: CallOverrides): Promise<BigNumber>;
        claimRewards(user: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        deposit(receiver: PromiseOrValue<string>, tokenIn: PromiseOrValue<string>, amountTokenToPull: PromiseOrValue<BigNumberish>, minSharesOut: PromiseOrValue<BigNumberish>, overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        exchangeRateCurrent(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        exchangeRateStored(overrides?: CallOverrides): Promise<BigNumber>;
        getBaseTokens(overrides?: CallOverrides): Promise<BigNumber>;
        getRewardTokens(overrides?: CallOverrides): Promise<BigNumber>;
        isValidBaseToken(token: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        redeem(receiver: PromiseOrValue<string>, amountSharesToPull: PromiseOrValue<BigNumberish>, tokenOut: PromiseOrValue<string>, minTokenOut: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        yieldToken(overrides?: CallOverrides): Promise<BigNumber>;
    };
    populateTransaction: {
        accruedRewards(user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        assetInfo(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        claimRewards(user: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        deposit(receiver: PromiseOrValue<string>, tokenIn: PromiseOrValue<string>, amountTokenToPull: PromiseOrValue<BigNumberish>, minSharesOut: PromiseOrValue<BigNumberish>, overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        exchangeRateCurrent(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        exchangeRateStored(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getBaseTokens(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getRewardTokens(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        isValidBaseToken(token: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        redeem(receiver: PromiseOrValue<string>, amountSharesToPull: PromiseOrValue<BigNumberish>, tokenOut: PromiseOrValue<string>, minTokenOut: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        yieldToken(overrides?: CallOverrides): Promise<PopulatedTransaction>;
    };
}
